



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Introduction to CELP Coding</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Introduction to CELP Coding</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 09:59:32 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>Speex is based on CELP, which stands for Code Excited Linear Prediction. This section attempts to introduce the principles behind CELP, so if you are already familiar with CELP, you can safely skip to section&nbsp;<a href="http://ntools.net/arc/Documents/speex/manual/node9.html#sec:Speex-narrowband-mode" rel="external nofollow noreferrer">7</a>. The CELP technique is based on three ideas:</p>
<ol><li>The use of a linear prediction (LP) model to model the vocal tract</li>
<li>The use of (adaptive and fixed) codebook entries as input (excitation) of the LP model</li>
<li>The search performed in closed-loop in a ``perceptually weighted domain''</li></ol>
<p>This section describes the basic ideas behind CELP. Note that it's still incomplete.</p>
<h2>Linear Prediction (LPC)</h2>
<p>Linear prediction is at the base of many speech coding techniques, including CELP. The idea behind it is to predict the signal&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img3.png" />&nbsp;using a linear combination of its past samples:</p>
<div><img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img4.png" /></div>
<p>where&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img5.png" />&nbsp;is the linear prediction of&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img3.png" />. The prediction error is thus given by:</p>
<div><img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img6.png" /></div>
<p>The goal of the LPC analysis is to find the best prediction coefficients&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img7.png" />&nbsp;which minimize the quadratic error function:</p>
<div><img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img8.png" /></div>
<p>That can be done by making all derivatives&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img9.png" />&nbsp;equal to zero:</p>
<div><img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img10.png" /></div>
<p>The&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img7.png" />&nbsp;filter coefficients are computed using the Levinson-Durbin&nbsp;algorithm, which starts from the auto-correlation&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img11.png" />&nbsp;of the signal&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img3.png" />.</p>
<div><img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img12.png" /></div>
<p>For an order&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img2.png" />&nbsp;filter, we have:</p>
<div><img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img13.png" /></div>
<div><img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img14.png" /></div>
<p>The filter coefficients&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img7.png" />&nbsp;are found by solving the system&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img15.png" />. What the Levinson-Durbin algorithm does here is making the solution to the problem&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img16.png" />instead of&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img17.png" />&nbsp;by exploiting the fact that matrix&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img18.png" />&nbsp;is toeplitz hermitian. Also, it can be proven that all the roots of&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img19.png" />&nbsp;are within the unit circle, which means that&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img20.png" />&nbsp;is always stable. This is in theory; in practice because of finite precision, there are two commonly used techniques to make sure we have a stable filter. First, we multiply&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img21.png" />&nbsp;by a number slightly above one (such as 1.0001), which is equivalent to adding noise to the signal. Also, we can apply a window to the auto-correlation, which is equivalent to filtering in the frequency domain, reducing sharp resonances.</p>
<p>The linear prediction model represents each speech sample as a linear combination of past samples, plus an error signal called the excitation (or residual).</p>
<div><img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img22.png" /></div>
<p>In the&nbsp;<em>z</em>-domain, this can be expressed as</p>
<div><img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img23.png" /></div>
<p>where&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img19.png" />&nbsp;is defined as</p>
<div><img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img24.png" /></div>
<p>We usually refer to&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img19.png" />&nbsp;as the analysis filter and&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img20.png" />&nbsp;as the synthesis filter. The whole process is called short-term prediction as it predicts the signal&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img3.png" />using a prediction using only the&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img2.png" />&nbsp;past samples, where&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img2.png" />&nbsp;is usually around 10.</p>
<p>Because LPC coefficients have very little robustness to quantization, they are converted to Line Spectral Pair&nbsp;(LSP) coefficients which have a much better behaviour with quantization, one of them being that it's easy to keep the filter stable.</p>
<h2>Pitch Prediction</h2>
<p>During voiced segments, the speech signal is periodic, so it is possible to take advantage of that property by approximating the excitation signal&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img25.png" />&nbsp;by a gain times the past of the excitation:</p>
<div><img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img26.png" /></div>
<p>where&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img27.png" />&nbsp;is the pitch period,&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img28.png" />&nbsp;is the pitch gain. We call that long-term prediction since the excitation is predicted from&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img29.png" />&nbsp;with&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img30.png" />.</p>
<h2>Innovation Codebook</h2>
<p>The final excitation&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img25.png" />&nbsp;will be the sum of the pitch prediction and an&nbsp;<em>innovation</em>&nbsp;signal&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img31.png" />&nbsp;taken from a fixed codebook, hence the name&nbsp;<em>Code</em>&nbsp;Excited Linear Prediction. The final excitation is given by:</p>
<div><img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img32.png" /></div>
<p>The quantization of&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img31.png" />&nbsp;is where most of the bits in a CELP codec are allocated. It represents the information that couldn't be obtained either from linear prediction or pitch prediction. In the&nbsp;<em>z</em>-domain we can represent the final signal&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img33.png" />&nbsp;as</p>
<div><img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img34.png" /></div>
<h2>Analysis-by-Synthesis and Error Weighting</h2>
<p>Most (if not all) modern audio codecs attempt to ``shape'' the noise so that it appears mostly in the frequency regions where the ear cannot detect it. For example, the ear is more tolerant to noise in parts of the spectrum that are louder and&nbsp;<em>vice versa</em>. That's why instead of minimizing the simple quadratic error</p>
<div><img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img35.png" /></div>
<p>where&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img36.png" />&nbsp;is the encoder signal, we minimize the error for the perceptually weighted signal</p>
<div><img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img37.png" /></div>
<p>where&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img38.png" />&nbsp;is the weighting filter, usually of the form</p>
<div>
<table>
<tbody>
<tr>
<td nowrap="nowrap"><img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img39.png" /></td>
<td>(1)</td>
</tr>
</tbody>
</table>
</div>
<p>with control parameters&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img40.png" />. If the noise is white in the perceptually weighted domain, then in the signal domain its spectral shape will be of the form</p>
<div><img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img41.png" /></div>
<p>If a filter&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img19.png" />&nbsp;has (complex) poles at&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img42.png" />&nbsp;in the&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img43.png" />-plane, the filter&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img44.png" />&nbsp;will have its poles at&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img45.png" />, making it a flatter version of&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img19.png" />.</p>
<p>Analysis-by-synthesis refers to the fact that when trying to find the best pitch parameters (<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img27.png" />,&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img28.png" />) and innovation signal&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img31.png" />, we do not work by making the excitation&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img25.png" />&nbsp;as close as the original one (which would be simpler), but apply the synthesis (and weighting) filter and try making&nbsp;<img referrerpolicy="no-referrer"src="http://ntools.net/arc/Documents/speex/manual/img46.png" />&nbsp;as close to the original as possible.</p>
<p>参考资料：</p>
<p>1 百科总结： https://zh.wikipedia.org/wiki/%E7%A0%81%E6%BF%80%E5%8A%B1%E7%BA%BF%E6%80%A7%E9%A2%84%E6%B5%8B <br />2 详细介绍： http://ntools.net/arc/Documents/speex/manual/node8.html</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2xvpv9.html">跟随Rodolfo进入VR时代！</a>
		</li>
						<li><a href="https://www.batexi.com/a/495lov68.html">jq对象转为dom对象：&dollar;&lpar;&amp;quot&semi;&period;div1&amp;quot&semi;&rpar;&lbrack;0&rsqb;    dom对象转为jq对象：&dollar;&lpar;dom对象&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jo34lq.html">【转】轮询、长轮询、iframe长连接、web socket</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yy5ynq.html">终端执行python shell的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1lp1k8.html">web2py--------------用web2py写 django的例子 --------建立一个投票应用&lpar;2&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnmvpe8.html">javadoc in archive eclipse&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y0l6nq.html">Android 不通过parent实现样式继承</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vwlym8.html">&lbrack;置顶&rsqb; C&plus;&plus;基础之六：运算符的重载</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kvke29.html">ACM博弈问题小试</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljvg0e9.html">在Android中使用枚举注解而不是枚举</a>
		</li>
						<li><a href="https://www.batexi.com/a/950vygv8.html">HTML5之contenteditable属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllem2kq.html">vue 添加旋转图片 修改css transform 值</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv25dxo9.html">二、volatile关键字 - 内存可见性</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25d25lq.html">C语言多种方法求解字符串编辑距离问题的代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o11zjpq.html">WebBrowser引用IE版本问题&comma;更改使用高版本IE</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyygvgxq.html">ajax-addclass</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwe25k8.html">Opentsdb 启动显示配置文件不存在</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w2vvzq.html">什么是UTF-8</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyym6yxq.html">Linux下SVN server 的使用及权限配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2km00wq.html">java接口对接&mdash;&mdash;调用别人接口推送数据</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qllp1vxq.html">Python：Fintech产品的第一语言</a>
			</li>
						<li><a href="https://www.batexi.com/a/960z32y9.html">CSS 图像</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllpnmeq.html">Java 虚拟机概述</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25ymjxq.html">yum方面的知识</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rwjk68.html">JVM参数类型</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rwjo58.html">HTML中的Meta标签详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdz5y09.html">Partition by使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/95g7wz6q.html">java通过年月得到该月每一天的日期</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllpvo1q.html">【CSS】自定义checkbox样式</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wg7z0q.html">centos查看系统版本</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
